From 94ae043f37ff179fb237d094df614a4be68d9f07 Mon Sep 17 00:00:00 2001
From: Wouter Vermeiren <wouter.vermeiren@essensium.com>
Date: Fri, 26 Jun 2020 10:27:45 +0200
Subject: [PATCH] patch1

---
 deps/v8/AUTHORS                               |   1 +
 deps/v8/BUILD.gn                              |  47 +++-
 deps/v8/gni/snapshot_toolchain.gni            |   4 +
 deps/v8/src/base/build_config.h               |  17 +-
 deps/v8/src/base/cpu.cc                       |   8 +-
 deps/v8/src/base/platform/platform-posix.cc   |   2 +-
 deps/v8/src/builtins/ppc/builtins-ppc.cc      |   4 +-
 deps/v8/src/codegen/assembler-arch.h          |   2 +-
 deps/v8/src/codegen/assembler-inl.h           |   2 +-
 deps/v8/src/codegen/constant-pool.cc          |   4 +-
 deps/v8/src/codegen/constant-pool.h           |   4 +-
 deps/v8/src/codegen/constants-arch.h          |   2 +-
 deps/v8/src/codegen/external-reference.cc     |   2 +-
 deps/v8/src/codegen/macro-assembler.h         |   2 +-
 deps/v8/src/codegen/ppc/assembler-ppc.cc      |  63 +++++-
 deps/v8/src/codegen/ppc/assembler-ppc.h       |   2 +
 deps/v8/src/codegen/ppc/constants-ppc.cc      |   4 +-
 deps/v8/src/codegen/ppc/constants-ppc.h       |  59 ++---
 deps/v8/src/codegen/ppc/cpu-ppc.cc            |   4 +-
 .../codegen/ppc/interface-descriptors-ppc.cc  |   4 +-
 .../v8/src/codegen/ppc/macro-assembler-ppc.cc | 139 +++++++++++-
 deps/v8/src/codegen/ppc/macro-assembler-ppc.h |   7 +
 deps/v8/src/codegen/ppc/register-ppc.h        |   6 +-
 deps/v8/src/codegen/register-arch.h           |   2 +-
 deps/v8/src/codegen/register-configuration.cc |   2 +
 deps/v8/src/codegen/reloc-info.cc             |   2 +-
 deps/v8/src/common/globals.h                  |  13 +-
 .../src/compiler/backend/instruction-codes.h  |   2 +
 .../compiler/backend/instruction-selector.cc  |  11 +-
 .../backend/ppc/code-generator-ppc.cc         | 168 +++++++++++++-
 .../backend/ppc/instruction-codes-ppc.h       |  25 +-
 .../backend/ppc/instruction-scheduler-ppc.cc  |  47 ++--
 .../backend/ppc/instruction-selector-ppc.cc   | 200 ++++++++++++++--
 .../backend/ppc/unwinding-info-writer-ppc.cc  | 105 +++++++++
 .../backend/ppc/unwinding-info-writer-ppc.h   |  73 ++++++
 .../backend/ppc64/instruction-codes-ppc64.h   | 213 ++++++++++++++++++
 .../compiler/backend/unwinding-info-writer.h  |   2 +
 deps/v8/src/compiler/c-linkage.cc             |   2 +-
 deps/v8/src/debug/debug-evaluate.cc           |   3 +-
 deps/v8/src/debug/ppc/debug-ppc.cc            |   4 +-
 deps/v8/src/diagnostics/eh-frame.cc           |   5 +-
 deps/v8/src/diagnostics/eh-frame.h            |   8 +-
 deps/v8/src/diagnostics/perf-jit.h            |   3 +
 deps/v8/src/diagnostics/ppc/disasm-ppc.cc     |   4 +-
 deps/v8/src/diagnostics/ppc/eh-frame-ppc.cc   |  85 +++++++
 deps/v8/src/execution/frame-constants.h       |   2 +-
 .../src/execution/ppc/frame-constants-ppc.cc  |   4 +-
 deps/v8/src/execution/ppc/simulator-ppc.cc    |  10 +
 deps/v8/src/execution/simulator-base.h        |   1 +
 deps/v8/src/execution/simulator.h             |   2 +-
 .../src/interpreter/interpreter-assembler.cc  |   3 +-
 deps/v8/src/libsampler/sampler.cc             |   6 +-
 deps/v8/src/logging/log.cc                    |   2 +
 deps/v8/src/objects/code.h                    |   3 +
 .../v8/src/objects/shared-function-info-inl.h |   2 +-
 deps/v8/src/profiler/tick-sample.cc           |   2 +-
 .../regexp/ppc/regexp-macro-assembler-ppc.cc  |   4 +-
 .../src/regexp/regexp-macro-assembler-arch.h  |   2 +-
 deps/v8/src/regexp/regexp.cc                  |   2 +-
 deps/v8/src/runtime/runtime-utils.h           |   2 +-
 deps/v8/src/snapshot/deserializer.h           |   2 +-
 deps/v8/src/wasm/baseline/liftoff-assembler.h |   2 +-
 deps/v8/src/wasm/jump-table-assembler.cc      |   2 +-
 deps/v8/src/wasm/jump-table-assembler.h       |   5 +
 deps/v8/src/wasm/wasm-serialization.cc        |   2 +-
 65 files changed, 1267 insertions(+), 161 deletions(-)
 create mode 100644 deps/v8/src/compiler/backend/ppc/unwinding-info-writer-ppc.cc
 create mode 100644 deps/v8/src/compiler/backend/ppc/unwinding-info-writer-ppc.h
 create mode 100644 deps/v8/src/compiler/backend/ppc64/instruction-codes-ppc64.h
 create mode 100644 deps/v8/src/diagnostics/ppc/eh-frame-ppc.cc

diff --git a/deps/v8/AUTHORS b/deps/v8/AUTHORS
index 1198de8f..28b0199b 100644
--- a/deps/v8/AUTHORS
+++ b/deps/v8/AUTHORS
@@ -191,6 +191,7 @@ Vladimir Krivosheev <develar@gmail.com>
 Vladimir Shutoff <vovan@shutoff.ru>
 Wenlu Wang <kingwenlu@gmail.com>
 Wiktor Garbacz <wiktor.garbacz@gmail.com>
+Wouter Vermeiren <wouter.vermeiren@mind.be>
 Xiaoyin Liu <xiaoyin.l@outlook.com>
 Yannic Bonenberger <contact@yannic-bonenberger.com>
 Yong Wang <ccyongwang@tencent.com>
diff --git a/deps/v8/BUILD.gn b/deps/v8/BUILD.gn
index 90ec4097..d97bfedd 100644
--- a/deps/v8/BUILD.gn
+++ b/deps/v8/BUILD.gn
@@ -603,8 +603,9 @@ config("toolchain") {
     }
   }
   if (v8_current_cpu == "ppc" || v8_current_cpu == "ppc64") {
-    defines += [ "V8_TARGET_ARCH_PPC" ]
-    if (v8_current_cpu == "ppc64") {
+    if (v8_current_cpu == "ppc") {
+      defines += [ "V8_TARGET_ARCH_PPC" ]
+    } else if (v8_current_cpu == "ppc64") {
       defines += [ "V8_TARGET_ARCH_PPC64" ]
     }
     if (host_byteorder == "little") {
@@ -1618,11 +1619,16 @@ v8_source_set("v8_initializers") {
       ### gcmole(arch:mips64el) ###
       "src/builtins/mips64/builtins-mips64.cc",
     ]
-  } else if (v8_current_cpu == "ppc" || v8_current_cpu == "ppc64") {
+  } else if (v8_current_cpu == "ppc") {
     sources += [
       ### gcmole(arch:ppc) ###
       "src/builtins/ppc/builtins-ppc.cc",
     ]
+  } else if (v8_current_cpu == "ppc64") {
+    sources += [
+      ### gcmole(arch:ppc64) ###
+      "src/builtins/ppc/builtins-ppc.cc",
+    ]
   } else if (v8_current_cpu == "s390" || v8_current_cpu == "s390x") {
     sources += [
       ### gcmole(arch:s390) ###
@@ -3221,7 +3227,7 @@ v8_source_set("v8_base_without_compiler") {
       "src/regexp/mips64/regexp-macro-assembler-mips64.h",
       "src/wasm/baseline/mips64/liftoff-assembler-mips64.h",
     ]
-  } else if (v8_current_cpu == "ppc" || v8_current_cpu == "ppc64") {
+  } else if (v8_current_cpu == "ppc") {
     sources += [  ### gcmole(arch:ppc) ###
       "src/codegen/ppc/assembler-ppc-inl.h",
       "src/codegen/ppc/assembler-ppc.cc",
@@ -3237,9 +3243,42 @@ v8_source_set("v8_base_without_compiler") {
       "src/compiler/backend/ppc/instruction-codes-ppc.h",
       "src/compiler/backend/ppc/instruction-scheduler-ppc.cc",
       "src/compiler/backend/ppc/instruction-selector-ppc.cc",
+      "src/compiler/backend/ppc/unwinding-info-writer-ppc.cc",
+      "src/compiler/backend/ppc/unwinding-info-writer-ppc.h",
+      "src/debug/ppc/debug-ppc.cc",
+      "src/deoptimizer/ppc/deoptimizer-ppc.cc",
+      "src/diagnostics/ppc/disasm-ppc.cc",
+      "src/diagnostics/ppc/eh-frame-ppc.cc",
+      "src/execution/ppc/frame-constants-ppc.cc",
+      "src/execution/ppc/frame-constants-ppc.h",
+      "src/execution/ppc/simulator-ppc.cc",
+      "src/execution/ppc/simulator-ppc.h",
+      "src/regexp/ppc/regexp-macro-assembler-ppc.cc",
+      "src/regexp/ppc/regexp-macro-assembler-ppc.h",
+      "src/wasm/baseline/ppc/liftoff-assembler-ppc.h",
+    ]
+  } else if (v8_current_cpu == "ppc64") {
+    sources += [  ### gcmole(arch:ppc64) ###
+      "src/codegen/ppc/assembler-ppc-inl.h",
+      "src/codegen/ppc/assembler-ppc.cc",
+      "src/codegen/ppc/assembler-ppc.h",
+      "src/codegen/ppc/constants-ppc.cc",
+      "src/codegen/ppc/constants-ppc.h",
+      "src/codegen/ppc/cpu-ppc.cc",
+      "src/codegen/ppc/interface-descriptors-ppc.cc",
+      "src/codegen/ppc/macro-assembler-ppc.cc",
+      "src/codegen/ppc/macro-assembler-ppc.h",
+      "src/codegen/ppc/register-ppc.h",
+      "src/compiler/backend/ppc/code-generator-ppc.cc",
+      "src/compiler/backend/ppc/instruction-codes-ppc.h",
+      "src/compiler/backend/ppc/instruction-scheduler-ppc.cc",
+      "src/compiler/backend/ppc/instruction-selector-ppc.cc",
+      "src/compiler/backend/ppc/unwinding-info-writer-ppc.cc",
+      "src/compiler/backend/ppc/unwinding-info-writer-ppc.h",
       "src/debug/ppc/debug-ppc.cc",
       "src/deoptimizer/ppc/deoptimizer-ppc.cc",
       "src/diagnostics/ppc/disasm-ppc.cc",
+      "src/diagnostics/ppc/eh-frame-ppc.cc",
       "src/execution/ppc/frame-constants-ppc.cc",
       "src/execution/ppc/frame-constants-ppc.h",
       "src/execution/ppc/simulator-ppc.cc",
diff --git a/deps/v8/gni/snapshot_toolchain.gni b/deps/v8/gni/snapshot_toolchain.gni
index b5fb1823..adda4717 100644
--- a/deps/v8/gni/snapshot_toolchain.gni
+++ b/deps/v8/gni/snapshot_toolchain.gni
@@ -89,6 +89,10 @@ if (v8_snapshot_toolchain == "") {
       }
     } else if (v8_current_cpu == "arm" || v8_current_cpu == "mipsel") {
       _cpus = "x86_v8_${v8_current_cpu}"
+    } else if (v8_current_cpu == "ppc") {
+      # reset clang to use gcc toolchain
+      _clang = ""
+      _cpus = "${v8_current_cpu}"
     } else {
       # This branch should not be reached; leave _cpus blank so the assert
       # below will fail.
diff --git a/deps/v8/src/base/build_config.h b/deps/v8/src/base/build_config.h
index f4300824..8d142c45 100644
--- a/deps/v8/src/base/build_config.h
+++ b/deps/v8/src/base/build_config.h
@@ -33,13 +33,12 @@
 #elif defined(__MIPSEB__) || defined(__MIPSEL__)
 #define V8_HOST_ARCH_MIPS 1
 #define V8_HOST_ARCH_32_BIT 1
+#elif defined(__PPC64__) || defined(_ARCH_PPC64)
+#define V8_HOST_ARCH_PPC64 1
+#define V8_HOST_ARCH_64_BIT 1
 #elif defined(__PPC__) || defined(_ARCH_PPC)
 #define V8_HOST_ARCH_PPC 1
-#if defined(__PPC64__) || defined(_ARCH_PPC64)
-#define V8_HOST_ARCH_64_BIT 1
-#else
 #define V8_HOST_ARCH_32_BIT 1
-#endif
 #elif defined(__s390__) || defined(__s390x__)
 #define V8_HOST_ARCH_S390 1
 #if defined(__s390x__)
@@ -78,7 +77,7 @@
 // environment as presented by the compiler.
 #if !V8_TARGET_ARCH_X64 && !V8_TARGET_ARCH_IA32 && !V8_TARGET_ARCH_ARM &&      \
     !V8_TARGET_ARCH_ARM64 && !V8_TARGET_ARCH_MIPS && !V8_TARGET_ARCH_MIPS64 && \
-    !V8_TARGET_ARCH_PPC && !V8_TARGET_ARCH_S390
+    !V8_TARGET_ARCH_PPC && !V8_TARGET_ARCH_PPC64 && !V8_TARGET_ARCH_S390
 #if defined(_M_X64) || defined(__x86_64__)
 #define V8_TARGET_ARCH_X64 1
 #elif defined(_M_IX86) || defined(__i386__)
@@ -91,6 +90,8 @@
 #define V8_TARGET_ARCH_MIPS64 1
 #elif defined(__MIPSEB__) || defined(__MIPSEL__)
 #define V8_TARGET_ARCH_MIPS 1
+#elif defined(_ARCH_PPC64)
+#define V8_TARGET_ARCH_PPC64 1
 #elif defined(_ARCH_PPC)
 #define V8_TARGET_ARCH_PPC 1
 #else
@@ -118,11 +119,9 @@
 #elif V8_TARGET_ARCH_MIPS64
 #define V8_TARGET_ARCH_64_BIT 1
 #elif V8_TARGET_ARCH_PPC
-#if V8_TARGET_ARCH_PPC64
-#define V8_TARGET_ARCH_64_BIT 1
-#else
 #define V8_TARGET_ARCH_32_BIT 1
-#endif
+#elif V8_TARGET_ARCH_PPC64
+#define V8_TARGET_ARCH_64_BIT 1
 #elif V8_TARGET_ARCH_S390
 #if V8_TARGET_ARCH_S390X
 #define V8_TARGET_ARCH_64_BIT 1
diff --git a/deps/v8/src/base/cpu.cc b/deps/v8/src/base/cpu.cc
index 6ab0ffee..53412bad 100644
--- a/deps/v8/src/base/cpu.cc
+++ b/deps/v8/src/base/cpu.cc
@@ -16,7 +16,7 @@
 #if V8_OS_QNX
 #include <sys/syspage.h>  // cpuinfo
 #endif
-#if V8_OS_LINUX && V8_HOST_ARCH_PPC
+#if (V8_OS_LINUX && (V8_HOST_ARCH_PPC || V8_HOST_ARCH_PPC64))
 #include <elf.h>
 #endif
 #if V8_OS_AIX
@@ -604,7 +604,7 @@ CPU::CPU()
 #elif V8_HOST_ARCH_ARM64
 // Implementer, variant and part are currently unused under ARM64.
 
-#elif V8_HOST_ARCH_PPC
+#elif V8_HOST_ARCH_PPC || V8_HOST_ARCH_PPC64
 
 #ifndef USE_SIMULATOR
 #if V8_OS_LINUX
@@ -653,6 +653,8 @@ CPU::CPU()
       part_ = PPC_G5;
     } else if (strcmp(auxv_cpu_type, "ppc7450") == 0) {
       part_ = PPC_G4;
+    } else if (strcmp(auxv_cpu_type, "ppc440") == 0) {
+      part_ = PPC_G4;
     } else if (strcmp(auxv_cpu_type, "pa6t") == 0) {
       part_ = PPC_PA6T;
     }
@@ -678,7 +680,7 @@ CPU::CPU()
   }
 #endif  // V8_OS_AIX
 #endif  // !USE_SIMULATOR
-#endif  // V8_HOST_ARCH_PPC
+#endif  // V8_HOST_ARCH_PPC || V8_HOST_ARCH_PPC64
 }
 
 }  // namespace base
diff --git a/deps/v8/src/base/platform/platform-posix.cc b/deps/v8/src/base/platform/platform-posix.cc
index c50cdd7a..5bfcc993 100644
--- a/deps/v8/src/base/platform/platform-posix.cc
+++ b/deps/v8/src/base/platform/platform-posix.cc
@@ -419,7 +419,7 @@ void OS::DebugBreak() {
   asm("break");
 #elif V8_HOST_ARCH_MIPS64
   asm("break");
-#elif V8_HOST_ARCH_PPC
+#elif V8_HOST_ARCH_PPC || V8_HOST_ARCH_PPC64
   asm("twge 2,2");
 #elif V8_HOST_ARCH_IA32
   asm("int $3");
diff --git a/deps/v8/src/builtins/ppc/builtins-ppc.cc b/deps/v8/src/builtins/ppc/builtins-ppc.cc
index 5ba797f8..fe65b4d9 100644
--- a/deps/v8/src/builtins/ppc/builtins-ppc.cc
+++ b/deps/v8/src/builtins/ppc/builtins-ppc.cc
@@ -2,7 +2,7 @@
 // Use of this source code is governed by a BSD-style license that can be
 // found in the LICENSE file.
 
-#if V8_TARGET_ARCH_PPC
+#if V8_TARGET_ARCH_PPC || V8_TARGET_ARCH_PPC64
 
 #include "src/api/api-arguments.h"
 #include "src/codegen/code-factory.h"
@@ -3337,4 +3337,4 @@ void Builtins::Generate_DirectCEntry(MacroAssembler* masm) {
 }  // namespace internal
 }  // namespace v8
 
-#endif  // V8_TARGET_ARCH_PPC
+#endif  // V8_TARGET_ARCH_PPC64 || V8_TARGET_ARCH_PPC64
diff --git a/deps/v8/src/codegen/assembler-arch.h b/deps/v8/src/codegen/assembler-arch.h
index cab4cbfc..d56b3725 100644
--- a/deps/v8/src/codegen/assembler-arch.h
+++ b/deps/v8/src/codegen/assembler-arch.h
@@ -15,7 +15,7 @@
 #include "src/codegen/arm64/assembler-arm64.h"
 #elif V8_TARGET_ARCH_ARM
 #include "src/codegen/arm/assembler-arm.h"
-#elif V8_TARGET_ARCH_PPC
+#elif V8_TARGET_ARCH_PPC || V8_TARGET_ARCH_PPC64
 #include "src/codegen/ppc/assembler-ppc.h"
 #elif V8_TARGET_ARCH_MIPS
 #include "src/codegen/mips/assembler-mips.h"
diff --git a/deps/v8/src/codegen/assembler-inl.h b/deps/v8/src/codegen/assembler-inl.h
index fd08a385..8c81315d 100644
--- a/deps/v8/src/codegen/assembler-inl.h
+++ b/deps/v8/src/codegen/assembler-inl.h
@@ -15,7 +15,7 @@
 #include "src/codegen/arm64/assembler-arm64-inl.h"
 #elif V8_TARGET_ARCH_ARM
 #include "src/codegen/arm/assembler-arm-inl.h"
-#elif V8_TARGET_ARCH_PPC
+#elif V8_TARGET_ARCH_PPC || V8_TARGET_ARCH_PPC64
 #include "src/codegen/ppc/assembler-ppc-inl.h"
 #elif V8_TARGET_ARCH_MIPS
 #include "src/codegen/mips/assembler-mips-inl.h"
diff --git a/deps/v8/src/codegen/constant-pool.cc b/deps/v8/src/codegen/constant-pool.cc
index 6816c5b7..745def6a 100644
--- a/deps/v8/src/codegen/constant-pool.cc
+++ b/deps/v8/src/codegen/constant-pool.cc
@@ -9,7 +9,7 @@
 namespace v8 {
 namespace internal {
 
-#if defined(V8_TARGET_ARCH_PPC)
+#if defined(V8_TARGET_ARCH_PPC) || defined(V8_TARGET_ARCH_PPC64)
 
 ConstantPoolBuilder::ConstantPoolBuilder(int ptr_reach_bits,
                                          int double_reach_bits) {
@@ -209,7 +209,7 @@ int ConstantPoolBuilder::Emit(Assembler* assm) {
   return !empty ? (assm->pc_offset() - emitted_label_.pos()) : 0;
 }
 
-#endif  // defined(V8_TARGET_ARCH_PPC)
+#endif  // defined(V8_TARGET_ARCH_PPC) || defined(V8_TARGET_ARCH_PPC64)
 
 #if defined(V8_TARGET_ARCH_ARM64)
 
diff --git a/deps/v8/src/codegen/constant-pool.h b/deps/v8/src/codegen/constant-pool.h
index d0745233..8823fbc4 100644
--- a/deps/v8/src/codegen/constant-pool.h
+++ b/deps/v8/src/codegen/constant-pool.h
@@ -81,7 +81,7 @@ class ConstantPoolEntry {
   enum { SHARING_PROHIBITED = -2, SHARING_ALLOWED = -1 };
 };
 
-#if defined(V8_TARGET_ARCH_PPC)
+#if defined(V8_TARGET_ARCH_PPC) || defined(V8_TARGET_ARCH_PPC64)
 
 // -----------------------------------------------------------------------------
 // Embedded constant pool support
@@ -162,7 +162,7 @@ class ConstantPoolBuilder {
   PerTypeEntryInfo info_[ConstantPoolEntry::NUMBER_OF_TYPES];
 };
 
-#endif  // defined(V8_TARGET_ARCH_PPC)
+#endif  // defined(V8_TARGET_ARCH_PPC) || defined(V8_TARGET_ARCH_PPC64)
 
 #if defined(V8_TARGET_ARCH_ARM64)
 
diff --git a/deps/v8/src/codegen/constants-arch.h b/deps/v8/src/codegen/constants-arch.h
index b49d2b64..7a222c96 100644
--- a/deps/v8/src/codegen/constants-arch.h
+++ b/deps/v8/src/codegen/constants-arch.h
@@ -15,7 +15,7 @@
 #include "src/codegen/mips/constants-mips.h"  // NOLINT
 #elif V8_TARGET_ARCH_MIPS64
 #include "src/codegen/mips64/constants-mips64.h"  // NOLINT
-#elif V8_TARGET_ARCH_PPC
+#elif V8_TARGET_ARCH_PPC || V8_TARGET_ARCH_PPC64
 #include "src/codegen/ppc/constants-ppc.h"  // NOLINT
 #elif V8_TARGET_ARCH_S390
 #include "src/codegen/s390/constants-s390.h"  // NOLINT
diff --git a/deps/v8/src/codegen/external-reference.cc b/deps/v8/src/codegen/external-reference.cc
index 44503e53..cca76e32 100644
--- a/deps/v8/src/codegen/external-reference.cc
+++ b/deps/v8/src/codegen/external-reference.cc
@@ -469,7 +469,7 @@ ExternalReference ExternalReference::invoke_accessor_getter_callback() {
 #define re_stack_check_func RegExpMacroAssemblerARM64::CheckStackGuardState
 #elif V8_TARGET_ARCH_ARM
 #define re_stack_check_func RegExpMacroAssemblerARM::CheckStackGuardState
-#elif V8_TARGET_ARCH_PPC
+#elif V8_TARGET_ARCH_PPC || V8_TARGET_ARCH_PPC64
 #define re_stack_check_func RegExpMacroAssemblerPPC::CheckStackGuardState
 #elif V8_TARGET_ARCH_MIPS
 #define re_stack_check_func RegExpMacroAssemblerMIPS::CheckStackGuardState
diff --git a/deps/v8/src/codegen/macro-assembler.h b/deps/v8/src/codegen/macro-assembler.h
index 0e588c08..e438d549 100644
--- a/deps/v8/src/codegen/macro-assembler.h
+++ b/deps/v8/src/codegen/macro-assembler.h
@@ -40,7 +40,7 @@ enum AllocationFlags {
 #elif V8_TARGET_ARCH_ARM
 #include "src/codegen/arm/constants-arm.h"
 #include "src/codegen/arm/macro-assembler-arm.h"
-#elif V8_TARGET_ARCH_PPC
+#elif V8_TARGET_ARCH_PPC || V8_TARGET_ARCH_PPC64
 #include "src/codegen/ppc/constants-ppc.h"
 #include "src/codegen/ppc/macro-assembler-ppc.h"
 #elif V8_TARGET_ARCH_MIPS
diff --git a/deps/v8/src/codegen/ppc/assembler-ppc.cc b/deps/v8/src/codegen/ppc/assembler-ppc.cc
index 2a638af0..998b33d3 100644
--- a/deps/v8/src/codegen/ppc/assembler-ppc.cc
+++ b/deps/v8/src/codegen/ppc/assembler-ppc.cc
@@ -36,7 +36,7 @@
 
 #include "src/codegen/ppc/assembler-ppc.h"
 
-#if V8_TARGET_ARCH_PPC
+#if V8_TARGET_ARCH_PPC || V8_TARGET_ARCH_PPC64
 
 #include "src/base/bits.h"
 #include "src/base/cpu.h"
@@ -1642,22 +1642,38 @@ void Assembler::fctiw(const DoubleRegister frt, const DoubleRegister frb) {
 
 void Assembler::frin(const DoubleRegister frt, const DoubleRegister frb,
                      RCBit rc) {
+#ifndef V8_TARGET_ARCH_PPC64
+  assert(false);
+#else
   emit(EXT4 | FRIN | frt.code() * B21 | frb.code() * B11 | rc);
+#endif
 }
 
 void Assembler::friz(const DoubleRegister frt, const DoubleRegister frb,
                      RCBit rc) {
+#ifndef V8_TARGET_ARCH_PPC64
+  assert(false);
+#else
   emit(EXT4 | FRIZ | frt.code() * B21 | frb.code() * B11 | rc);
+#endif
 }
 
 void Assembler::frip(const DoubleRegister frt, const DoubleRegister frb,
                      RCBit rc) {
+#ifndef V8_TARGET_ARCH_PPC64
+  assert(false);
+#else
   emit(EXT4 | FRIP | frt.code() * B21 | frb.code() * B11 | rc);
+#endif
 }
 
 void Assembler::frim(const DoubleRegister frt, const DoubleRegister frb,
                      RCBit rc) {
+#ifndef V8_TARGET_ARCH_PPC64
+  assert(false);
+#else
   emit(EXT4 | FRIM | frt.code() * B21 | frb.code() * B11 | rc);
+#endif
 }
 
 void Assembler::frsp(const DoubleRegister frt, const DoubleRegister frb,
@@ -1667,42 +1683,74 @@ void Assembler::frsp(const DoubleRegister frt, const DoubleRegister frb,
 
 void Assembler::fcfid(const DoubleRegister frt, const DoubleRegister frb,
                       RCBit rc) {
+ #ifndef V8_TARGET_ARCH_PPC64
+  assert(false);
+#else
   emit(EXT4 | FCFID | frt.code() * B21 | frb.code() * B11 | rc);
+#endif
 }
 
 void Assembler::fcfidu(const DoubleRegister frt, const DoubleRegister frb,
                        RCBit rc) {
+#ifndef V8_TARGET_ARCH_PPC64
+  assert(false);
+#else
   emit(EXT4 | FCFIDU | frt.code() * B21 | frb.code() * B11 | rc);
+#endif
 }
 
 void Assembler::fcfidus(const DoubleRegister frt, const DoubleRegister frb,
                         RCBit rc) {
+#ifndef V8_TARGET_ARCH_PPC64
+  assert(false);
+#else
   emit(EXT3 | FCFIDUS | frt.code() * B21 | frb.code() * B11 | rc);
+#endif
 }
 
 void Assembler::fcfids(const DoubleRegister frt, const DoubleRegister frb,
                        RCBit rc) {
+#ifndef V8_TARGET_ARCH_PPC64
+  assert(false);
+#else
   emit(EXT3 | FCFIDS | frt.code() * B21 | frb.code() * B11 | rc);
+#endif
 }
 
 void Assembler::fctid(const DoubleRegister frt, const DoubleRegister frb,
                       RCBit rc) {
+#ifndef V8_TARGET_ARCH_PPC64
+  assert(false);
+#else
   emit(EXT4 | FCTID | frt.code() * B21 | frb.code() * B11 | rc);
+#endif
 }
 
 void Assembler::fctidz(const DoubleRegister frt, const DoubleRegister frb,
                        RCBit rc) {
+#ifndef V8_TARGET_ARCH_PPC64
+  assert(false);
+#else
   emit(EXT4 | FCTIDZ | frt.code() * B21 | frb.code() * B11 | rc);
+#endif
 }
 
 void Assembler::fctidu(const DoubleRegister frt, const DoubleRegister frb,
                        RCBit rc) {
+#ifndef V8_TARGET_ARCH_PPC64
+  assert(false);
+#else
   emit(EXT4 | FCTIDU | frt.code() * B21 | frb.code() * B11 | rc);
+#endif
 }
 
 void Assembler::fctiduz(const DoubleRegister frt, const DoubleRegister frb,
                         RCBit rc) {
+#ifndef V8_TARGET_ARCH_PPC64
+  assert(false);
+#else
   emit(EXT4 | FCTIDUZ | frt.code() * B21 | frb.code() * B11 | rc);
+#endif
 }
 
 void Assembler::fsel(const DoubleRegister frt, const DoubleRegister fra,
@@ -1744,7 +1792,18 @@ void Assembler::mtfsf(const DoubleRegister frb, bool L, int FLM, bool W,
 
 void Assembler::fsqrt(const DoubleRegister frt, const DoubleRegister frb,
                       RCBit rc) {
+#ifndef USE_SIMULATOR
+#if V8_TARGET_ARCH_PPC
+  assert(false);
+#endif
+#else
   emit(EXT4 | FSQRT | frt.code() * B21 | frb.code() * B11 | rc);
+#endif
+}
+
+void Assembler::frsqrte(const DoubleRegister frt, const DoubleRegister frb,
+                      RCBit rc) {
+  emit(EXT4 | FRSQRTE | frt.code() * B21 | frb.code() * B11 | rc);
 }
 
 void Assembler::fabs(const DoubleRegister frt, const DoubleRegister frb,
@@ -1969,4 +2028,4 @@ Register UseScratchRegisterScope::Acquire() {
 }  // namespace internal
 }  // namespace v8
 
-#endif  // V8_TARGET_ARCH_PPC
+#endif  // V8_TARGET_ARCH_PPC || V8_TARGET_ARCH_PPC64
diff --git a/deps/v8/src/codegen/ppc/assembler-ppc.h b/deps/v8/src/codegen/ppc/assembler-ppc.h
index dee264a7..e4d7ff4f 100644
--- a/deps/v8/src/codegen/ppc/assembler-ppc.h
+++ b/deps/v8/src/codegen/ppc/assembler-ppc.h
@@ -916,6 +916,8 @@ class Assembler : public AssemblerBase {
              RCBit rc = LeaveRC);
   void fsqrt(const DoubleRegister frt, const DoubleRegister frb,
              RCBit rc = LeaveRC);
+  void frsqrte(const DoubleRegister frt, const DoubleRegister frb,
+          RCBit rc);
   void fabs(const DoubleRegister frt, const DoubleRegister frb,
             RCBit rc = LeaveRC);
   void fmadd(const DoubleRegister frt, const DoubleRegister fra,
diff --git a/deps/v8/src/codegen/ppc/constants-ppc.cc b/deps/v8/src/codegen/ppc/constants-ppc.cc
index 4cee2cbc..ee2e19aa 100644
--- a/deps/v8/src/codegen/ppc/constants-ppc.cc
+++ b/deps/v8/src/codegen/ppc/constants-ppc.cc
@@ -2,7 +2,7 @@
 // Use of this source code is governed by a BSD-style license that can be
 // found in the LICENSE file.
 
-#if V8_TARGET_ARCH_PPC
+#if V8_TARGET_ARCH_PPC || V8_TARGET_ARCH_PPC64
 
 #include "src/codegen/ppc/constants-ppc.h"
 
@@ -46,4 +46,4 @@ int Registers::Number(const char* name) {
 }  // namespace internal
 }  // namespace v8
 
-#endif  // V8_TARGET_ARCH_PPC
+#endif  // V8_TARGET_ARCH_PPC || V8_TARGET_ARCH_PPC64
